import{s as qe,n as ze,o as Ae}from"../chunks/scheduler.37c15a92.js";import{S as je,i as Se,g as r,s as a,r as A,A as Be,h as l,f as n,c as o,j as Pe,u as j,x as s,k as ke,y as Ee,a as i,v as S,d as B,t as E,w as I}from"../chunks/index.7cb9c9b8.js";import{H as D}from"../chunks/Heading.d3928e2a.js";function Ie(ue){let p,F,q,G,m,N,d,fe=`In this advanced topic, we address the question: <strong>how should we monitor and keep track of powerful reinforcement learning agents that we are training in the real world and
interfacing with humans?</strong>`,U,u,he="As machine learning systems have increasingly impacted modern life, the <strong>call for the documentation of these systems has grown</strong>.",W,f,ce=`Such documentation can cover aspects such as the training data used — where it is stored, when it was collected, who was involved, etc.
— or the model optimization framework — the architecture, evaluation metrics, relevant papers, etc. — and more.`,J,h,ge=`Today, model cards and datasheets are becoming increasingly available. For example, on the Hub
(see documentation <a href="https://huggingface.co/docs/hub/model-cards" rel="nofollow">here</a>).`,K,c,we='If you click on a <a href="https://huggingface.co/models" rel="nofollow">popular model on the Hub</a>, you can learn about its creation process.',O,g,ve=`These model and data specific logs are designed to be completed when the model or dataset are created, leaving them to go un-updated when these models are built into evolving systems in the future.
​`,Q,w,V,v,be=`Reinforcement learning systems are fundamentally designed to optimize based on measurements of reward and time.
While the notion of a reward function can be mapped nicely to many well-understood fields of supervised learning (via a loss function),
understanding of how machine learning systems evolve over time is limited.`,X,b,xe=`To that end, the authors introduce <a href="https://www.notion.so/Brief-introduction-to-RL-documentation-b8cbda5a6f5242338e0756e6bef72af4" rel="nofollow"><em>Reward Reports for Reinforcement Learning</em></a> (the pithy naming is designed to mirror the popular papers <em>Model Cards for Model Reporting</em> and <em>Datasheets for Datasets</em>).
The goal is to propose a type of documentation focused on the <strong>human factors of reward</strong> and <strong>time-varying feedback systems</strong>.`,Y,x,$e='Building on the documentation frameworks for <a href="https://arxiv.org/abs/1810.03993" rel="nofollow">model cards</a> and <a href="https://arxiv.org/abs/1803.09010" rel="nofollow">datasheets</a> proposed by Mitchell et al. and Gebru et al., we argue the need for Reward Reports for AI systems.',Z,$,ye="<strong>Reward Reports</strong> are living documents for proposed RL deployments that demarcate design choices.",ee,y,Ce=`However, many questions remain about the applicability of this framework to different RL applications, roadblocks to system interpretability,
and the resonances between deployed supervised machine learning systems and the sequential decision-making utilized in RL.`,te,C,Te=`At a minimum, Reward Reports are an opportunity for RL practitioners to deliberate on these questions and begin the work of deciding how to resolve them in practice.
​`,ne,T,ie,L,Le=`The core piece specific to documentation designed for RL and feedback-driven ML systems is a <em>change-log</em>. The change-log updates information
from the designer (changed training parameters, data, etc.) along with noticed changes from the user (harmful behavior, unexpected responses, etc.).`,ae,R,Re="The change log is accompanied by update triggers that encourage monitoring these effects.",oe,_,re,M,_e=`Some of the most impactful RL-driven systems are multi-stakeholder in nature and behind the closed doors of private corporations.
These corporations are largely without regulation, so the burden of documentation falls on the public.`,le,H,Me=`If you are interested in contributing, we are building Reward Reports for popular machine learning systems on a public
record on <a href="https://github.com/RewardReports/reward-reports" rel="nofollow">GitHub</a>.
​
For further reading, you can visit the Reward Reports <a href="https://arxiv.org/abs/2204.10817" rel="nofollow">paper</a>
or look <a href="https://github.com/RewardReports/reward-reports/tree/main/examples" rel="nofollow">an example report</a>.`,se,P,pe,k,He='This section was written by <a href="https://twitter.com/natolambert">Nathan Lambert</a>',me,z,de;return m=new D({props:{title:"Brief introduction to RL documentation",local:"brief-introduction-to-rl-documentation",headingTag:"h1"}}),w=new D({props:{title:"Motivating Reward Reports",local:"motivating-reward-reports",headingTag:"h2"}}),T=new D({props:{title:"Capturing temporal behavior with documentation",local:"capturing-temporal-behavior-with-documentation",headingTag:"h2"}}),_=new D({props:{title:"Contributing",local:"contributing",headingTag:"h2"}}),P=new D({props:{title:"Author",local:"author",headingTag:"h2"}}),{c(){p=r("meta"),F=a(),q=r("p"),G=a(),A(m.$$.fragment),N=a(),d=r("p"),d.innerHTML=fe,U=a(),u=r("p"),u.innerHTML=he,W=a(),f=r("p"),f.textContent=ce,J=a(),h=r("p"),h.innerHTML=ge,K=a(),c=r("p"),c.innerHTML=we,O=a(),g=r("p"),g.textContent=ve,Q=a(),A(w.$$.fragment),V=a(),v=r("p"),v.textContent=be,X=a(),b=r("p"),b.innerHTML=xe,Y=a(),x=r("p"),x.innerHTML=$e,Z=a(),$=r("p"),$.innerHTML=ye,ee=a(),y=r("p"),y.textContent=Ce,te=a(),C=r("p"),C.textContent=Te,ne=a(),A(T.$$.fragment),ie=a(),L=r("p"),L.innerHTML=Le,ae=a(),R=r("p"),R.textContent=Re,oe=a(),A(_.$$.fragment),re=a(),M=r("p"),M.textContent=_e,le=a(),H=r("p"),H.innerHTML=Me,se=a(),A(P.$$.fragment),pe=a(),k=r("p"),k.innerHTML=He,me=a(),z=r("p"),this.h()},l(e){const t=Be("svelte-u9bgzb",document.head);p=l(t,"META",{name:!0,content:!0}),t.forEach(n),F=o(e),q=l(e,"P",{}),Pe(q).forEach(n),G=o(e),j(m.$$.fragment,e),N=o(e),d=l(e,"P",{"data-svelte-h":!0}),s(d)!=="svelte-vtjhob"&&(d.innerHTML=fe),U=o(e),u=l(e,"P",{"data-svelte-h":!0}),s(u)!=="svelte-1fronss"&&(u.innerHTML=he),W=o(e),f=l(e,"P",{"data-svelte-h":!0}),s(f)!=="svelte-18x38zx"&&(f.textContent=ce),J=o(e),h=l(e,"P",{"data-svelte-h":!0}),s(h)!=="svelte-1dlzh15"&&(h.innerHTML=ge),K=o(e),c=l(e,"P",{"data-svelte-h":!0}),s(c)!=="svelte-11x8tuw"&&(c.innerHTML=we),O=o(e),g=l(e,"P",{"data-svelte-h":!0}),s(g)!=="svelte-1m80jls"&&(g.textContent=ve),Q=o(e),j(w.$$.fragment,e),V=o(e),v=l(e,"P",{"data-svelte-h":!0}),s(v)!=="svelte-uuu9we"&&(v.textContent=be),X=o(e),b=l(e,"P",{"data-svelte-h":!0}),s(b)!=="svelte-163ow0b"&&(b.innerHTML=xe),Y=o(e),x=l(e,"P",{"data-svelte-h":!0}),s(x)!=="svelte-iy1n1"&&(x.innerHTML=$e),Z=o(e),$=l(e,"P",{"data-svelte-h":!0}),s($)!=="svelte-1q2xcek"&&($.innerHTML=ye),ee=o(e),y=l(e,"P",{"data-svelte-h":!0}),s(y)!=="svelte-j1zl9k"&&(y.textContent=Ce),te=o(e),C=l(e,"P",{"data-svelte-h":!0}),s(C)!=="svelte-1w6v3rz"&&(C.textContent=Te),ne=o(e),j(T.$$.fragment,e),ie=o(e),L=l(e,"P",{"data-svelte-h":!0}),s(L)!=="svelte-5kkp2w"&&(L.innerHTML=Le),ae=o(e),R=l(e,"P",{"data-svelte-h":!0}),s(R)!=="svelte-1j0m0fx"&&(R.textContent=Re),oe=o(e),j(_.$$.fragment,e),re=o(e),M=l(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-i3qq7q"&&(M.textContent=_e),le=o(e),H=l(e,"P",{"data-svelte-h":!0}),s(H)!=="svelte-ihbc3x"&&(H.innerHTML=Me),se=o(e),j(P.$$.fragment,e),pe=o(e),k=l(e,"P",{"data-svelte-h":!0}),s(k)!=="svelte-17c4ke5"&&(k.innerHTML=He),me=o(e),z=l(e,"P",{}),Pe(z).forEach(n),this.h()},h(){ke(p,"name","hf:doc:metadata"),ke(p,"content",De)},m(e,t){Ee(document.head,p),i(e,F,t),i(e,q,t),i(e,G,t),S(m,e,t),i(e,N,t),i(e,d,t),i(e,U,t),i(e,u,t),i(e,W,t),i(e,f,t),i(e,J,t),i(e,h,t),i(e,K,t),i(e,c,t),i(e,O,t),i(e,g,t),i(e,Q,t),S(w,e,t),i(e,V,t),i(e,v,t),i(e,X,t),i(e,b,t),i(e,Y,t),i(e,x,t),i(e,Z,t),i(e,$,t),i(e,ee,t),i(e,y,t),i(e,te,t),i(e,C,t),i(e,ne,t),S(T,e,t),i(e,ie,t),i(e,L,t),i(e,ae,t),i(e,R,t),i(e,oe,t),S(_,e,t),i(e,re,t),i(e,M,t),i(e,le,t),i(e,H,t),i(e,se,t),S(P,e,t),i(e,pe,t),i(e,k,t),i(e,me,t),i(e,z,t),de=!0},p:ze,i(e){de||(B(m.$$.fragment,e),B(w.$$.fragment,e),B(T.$$.fragment,e),B(_.$$.fragment,e),B(P.$$.fragment,e),de=!0)},o(e){E(m.$$.fragment,e),E(w.$$.fragment,e),E(T.$$.fragment,e),E(_.$$.fragment,e),E(P.$$.fragment,e),de=!1},d(e){e&&(n(F),n(q),n(G),n(N),n(d),n(U),n(u),n(W),n(f),n(J),n(h),n(K),n(c),n(O),n(g),n(Q),n(V),n(v),n(X),n(b),n(Y),n(x),n(Z),n($),n(ee),n(y),n(te),n(C),n(ne),n(ie),n(L),n(ae),n(R),n(oe),n(re),n(M),n(le),n(H),n(se),n(pe),n(k),n(me),n(z)),n(p),I(m,e),I(w,e),I(T,e),I(_,e),I(P,e)}}}const De='{"title":"Brief introduction to RL documentation","local":"brief-introduction-to-rl-documentation","sections":[{"title":"Motivating Reward Reports","local":"motivating-reward-reports","sections":[],"depth":2},{"title":"Capturing temporal behavior with documentation","local":"capturing-temporal-behavior-with-documentation","sections":[],"depth":2},{"title":"Contributing","local":"contributing","sections":[],"depth":2},{"title":"Author","local":"author","sections":[],"depth":2}],"depth":1}';function Fe(ue){return Ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class We extends je{constructor(p){super(),Se(this,p,Fe,Ie,qe,{})}}export{We as component};
