import{s as Xl,f as w,n as Yl,o as Zl}from"../chunks/scheduler.37c15a92.js";import{S as sp,i as ap,g as l,s as m,r as ve,m as r,H as h,A as tp,h as p,f as a,c as i,j as o,u as de,x as g,n as c,B as u,k as v,y as n,a as e,v as ye,d as fe,t as we,w as be}from"../chunks/index.7cb9c9b8.js";import{H as xe}from"../chunks/Heading.d3928e2a.js";function np(_e){let _,oa,ea,ha,H,ga,P,Me="The last thing we need to discuss before diving into Q-Learning is the two learning strategies.",ua,I,ze="Remember that an RL agent <strong>learns by interacting with its environment.</strong> The idea is that <strong>given the experience and the received reward, the agent will update its value function or policy.</strong>",va,D,ke="Monte Carlo and Temporal Difference Learning are two different <strong>strategies on how to train our value function or our policy function.</strong> Both of them <strong>use experience to solve the RL problem.</strong>",da,M,un,_s,Le="an entire episode of experience before learning.",vn,$,dn,ya,xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo separator="true">,</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_t, A_t, R_{t+1}, S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',fa,wa,j,Te="We’ll explain both of them <strong>using a value-based method example.</strong>",ba,N,xa,z,yn,_a,_l='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ma,O,fn,za,Ml='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ka,La,W,Se="So it requires a <strong>complete episode of interaction before updating our value function.</strong>",Ta,q,Ce,Sa,U,Ge="If we take an example:",Ca,A,Ve,Ga,d,Ms,Re="<p>We always start the episode <strong>at the same starting point.</strong></p>",wn,zs,Ee="<p><strong>The agent takes actions using the policy</strong>. For instance, using an Epsilon Greedy Strategy, a policy that alternates between exploration (random actions) and exploitation.</p>",bn,ks,He="<p>We get <strong>the reward and the next state.</strong></p>",xn,Ls,Pe="<p>We terminate the episode if the cat eats the mouse or if the mouse moves &gt; 10 steps.</p>",_n,Ts,Ie=`<p>At the end of the episode, <strong>we have a list of State, Actions, Rewards, and Next States tuples</strong>
For instance [[State tile 3 bottom, Go Left, +1, State tile 2 bottom], [State tile 2 bottom, Go Left, +0, State tile 1 bottom]…]</p>`,Mn,la,Ss,Cs,zn,Va,zl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',kn,Ln,B,Gs,Tn,F,Sn,Ra,kl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(s_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ea,Cn,Vs,De,Gn,Rs,$e="<p>Then <strong>start a new game with this new knowledge</strong></p>",Ha,Q,je="By running more and more episodes, <strong>the agent will learn to play better and better.</strong>",Pa,J,Ne,Ia,K,Oe="For instance, if we train a state-value function using Monte Carlo:",Da,X,We='<li><p>We initialize our value function <strong>so that it returns 0 value for each state</strong></p></li> <li><p>Our learning rate (lr) is 0.1 and our discount rate is 1 (= no discount)</p></li> <li><p>Our mouse <strong>explores the environment and takes random actions</strong></p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4.jpg" alt="Monte Carlo"/></li>',$a,Y,qe='<li><p>The mouse made more than 10 steps, so the episode ends .</p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4p.jpg" alt="Monte Carlo"/></li>',ja,Es,Hs,Vn,Ps,Rn,Na,Ll='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>G</mi><mrow><mi>t</mi><mo>=</mo><mn>0</mn></mrow></mrow><annotation encoding="application/x-tex">G{t=0}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6833em;"></span><span class="mord mathnormal">G</span><span class="mord"><span class="mord mathnormal">t</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mord">0</span></span></span></span></span>',Oa,Z,Wa,Tl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub><mo>=</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>2</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>3</mn></mrow></msub><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi></mrow><annotation encoding="application/x-tex">G_t = R_{t+1} + R_{t+2} + R_{t+3} ...</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mord">...</span></span></span></span>',qa,Ua,Is,Aa,Sl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><msub><mi>R</mi><mn>2</mn></msub><mo>+</mo><msub><mi>R</mi><mn>3</mn></msub><mo>…</mo></mrow><annotation encoding="application/x-tex">G_0 = R_{1} + R_{2} + R_{3}…</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.1667em;"></span><span class="minner">…</span></span></span></span>',Ba,Ds,Fa,Cl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn></mrow><annotation encoding="application/x-tex">G_0 = 1 + 0 + 0 + 0 + 0 + 0 + 1 + 1 + 0 + 0</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0</span></span></span></span>',Qa,$s,Ja,Gl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>3</mn></mrow><annotation encoding="application/x-tex">G_0 = 3</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">3</span></span></span></span>',Ka,js,ss,k,En,Ns,Ue="new",Hn,Xa,Vl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ya,Pn,Os,Ae,Za,Ws,st,Rl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>G</mi><mn>0</mn></msub><mtext>—</mtext><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [G_0 — V(S_0)]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">—</span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',at,qs,tt,El='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>3</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [3 – 0]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">3–0</span><span class="mclose">]</span></span></span></span>',nt,Us,et,Hl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.3</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.3</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.3</span></span></span></span>',lt,as,Be,pt,ts,mt,f,As,In,it,Pl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Dn,rt,Il='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ct,ot,Dl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',ht,gt,$l='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\gamma * V(S_{t+1})</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ut,vt,ns,$n,es,jn,dt,jl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',yt,ft,L,Nn,wt,Nl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',bt,T,On,xt,Ol='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',_t,Mt,Wl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',zt,kt,ls,Wn,S,qn,Lt,ql='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_{t+1})</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Tt,St,Ul='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ct,Gt,ps,Fe,Vt,ms,Qe="This method is called TD(0) or <strong>one-step TD (update the value function after any individual step).</strong>",Rt,is,Je,Et,rs,Ke="If we take the same example,",Ht,cs,Xe,Pt,b,Bs,Ye="<p>We initialize our value function so that it returns 0 value for each state.</p>",Un,Fs,Ze="<p>Our learning rate (lr) is 0.1, and our discount rate is 1 (no discount).</p>",An,Qs,sl="<p>Our mouse begins to explore the environment and takes a random action: <strong>going to the left</strong></p>",Bn,os,G,Fn,It,Al='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',Dt,Js,al="it eats a piece of cheese",Qn,Ks,tl,$t,hs,nl,jt,V,Jn,Nt,Bl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ot,Wt,gs,Kn,qt,Fl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>1</mn></msub><mo stretchy="false">)</mo><mo>−</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [R_1 + \\gamma * V(S_1) - V(S_0)]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',Ut,us,Xn,At,Ql='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>∗</mo><mn>0</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [1 + 1 * 0–0]</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">0–0</span><span class="mclose">]</span></span></span></span>',Bt,vs,Yn,Ft,Jl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.1</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span></span></span></span>',Qt,ds,el="So we just updated our value function for State 0.",Jt,ys,ll="Now we <strong>continue to interact with this environment with our updated value function.</strong>",Kt,fs,pl,Xt,ws,ml="To summarize:",Yt,R,Xs,il="<p>With <em>Monte Carlo</em>, we update the value function from a complete episode, and so we <strong>use the actual accurate discounted return of this episode.</strong></p>",Zn,bs,x,se,Ys,rl="TD Learning",ae,Zt,Kl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',sn,Zs,cl="an estimated return called the TD target.",te,sa,ol,an,pa,tn;return H=new xe({props:{title:"Monte Carlo vs Temporal Difference Learning",local:"mc-vs-td",headingTag:"h1"}}),N=new xe({props:{title:"Monte Carlo: learning at the end of the episode",local:"monte-carlo",headingTag:"h2"}}),ts=new xe({props:{title:"Temporal Difference Learning: learning at each step",local:"td-learning",headingTag:"h2"}}),{c(){_=l("meta"),oa=m(),ea=l("p"),ha=m(),ve(H.$$.fragment),ga=m(),P=l("p"),P.textContent=Me,ua=m(),I=l("p"),I.innerHTML=ze,va=m(),D=l("p"),D.innerHTML=ke,da=m(),M=l("p"),un=r("On one hand, Monte Carlo uses "),_s=l("strong"),_s.textContent=Le,vn=r(" On the other hand, Temporal Difference uses "),$=l("strong"),dn=r("only a step ( "),ya=new h(!1),fa=r(" ) to learn."),wa=m(),j=l("p"),j.innerHTML=Te,ba=m(),ve(N.$$.fragment),xa=m(),z=l("p"),yn=r("Monte Carlo waits until the end of the episode, calculates  "),_a=new h(!1),Ma=r(" (return) and uses it as "),O=l("strong"),fn=r("a target for updating  "),za=new h(!1),ka=r("."),La=m(),W=l("p"),W.innerHTML=Se,Ta=m(),q=l("img"),Sa=m(),U=l("p"),U.textContent=Ge,Ca=m(),A=l("img"),Ga=m(),d=l("ul"),Ms=l("li"),Ms.innerHTML=Re,wn=m(),zs=l("li"),zs.innerHTML=Ee,bn=m(),ks=l("li"),ks.innerHTML=He,xn=m(),Ls=l("li"),Ls.innerHTML=Pe,_n=m(),Ts=l("li"),Ts.innerHTML=Ie,Mn=m(),la=l("li"),Ss=l("p"),Cs=l("strong"),zn=r("The agent will sum the total rewards "),Va=new h(!1),kn=r(" (to see how well it did)."),Ln=m(),B=l("li"),Gs=l("p"),Tn=r("It will then "),F=l("strong"),Sn=r("update "),Ra=new h(!1),Ea=r(" based on the formula"),Cn=m(),Vs=l("img"),Gn=m(),Rs=l("li"),Rs.innerHTML=$e,Ha=m(),Q=l("p"),Q.innerHTML=je,Pa=m(),J=l("img"),Ia=m(),K=l("p"),K.textContent=Oe,Da=m(),X=l("ul"),X.innerHTML=We,$a=m(),Y=l("ul"),Y.innerHTML=qe,ja=m(),Es=l("ul"),Hs=l("li"),Vn=r("We have a list of state, action, rewards, next_state, "),Ps=l("strong"),Rn=r("we need to calculate the return "),Na=new h(!1),Oa=m(),Z=l("p"),Wa=new h(!1),qa=r(" (for simplicity, we don’t discount the rewards)"),Ua=m(),Is=l("p"),Aa=new h(!1),Ba=m(),Ds=l("p"),Fa=new h(!1),Qa=m(),$s=l("p"),Ja=new h(!1),Ka=m(),js=l("ul"),ss=l("li"),k=l("p"),En=r("We can now compute the "),Ns=l("strong"),Ns.textContent=Ue,Hn=m(),Xa=new h(!1),Ya=r(":"),Pn=m(),Os=l("img"),Za=m(),Ws=l("p"),st=new h(!1),at=m(),qs=l("p"),tt=new h(!1),nt=m(),Us=l("p"),et=new h(!1),lt=m(),as=l("img"),pt=m(),ve(ts.$$.fragment),mt=m(),f=l("p"),As=l("strong"),In=r("Temporal Difference, on the other hand, waits for only one interaction (one step) "),it=new h(!1),Dn=r(" to form a TD target and update "),rt=new h(!1),ct=r(" using "),ot=new h(!1),ht=r(" and "),gt=new h(!1),ut=r("."),vt=m(),ns=l("p"),$n=r("The idea with "),es=l("strong"),jn=r("TD is to update the "),dt=new h(!1),yt=r(" at each step."),ft=m(),L=l("p"),Nn=r("But because we didn’t experience an entire episode, we don’t have "),wt=new h(!1),bt=r(" (expected return). Instead, "),T=l("strong"),On=r("we estimate "),xt=new h(!1),_t=r(" by adding "),Mt=new h(!1),zt=r(" and the discounted value of the next state."),kt=m(),ls=l("p"),Wn=r("This is called bootstrapping. It’s called this "),S=l("strong"),qn=r("because TD bases its update in part on an existing estimate "),Lt=new h(!1),Tt=r(" and not a complete sample "),St=new h(!1),Ct=r("."),Gt=m(),ps=l("img"),Vt=m(),ms=l("p"),ms.innerHTML=Qe,Rt=m(),is=l("img"),Et=m(),rs=l("p"),rs.textContent=Ke,Ht=m(),cs=l("img"),Pt=m(),b=l("ul"),Bs=l("li"),Bs.innerHTML=Ye,Un=m(),Fs=l("li"),Fs.innerHTML=Ze,An=m(),Qs=l("li"),Qs.innerHTML=sl,Bn=m(),os=l("li"),G=l("p"),Fn=r("It gets a reward  "),It=new h(!1),Dt=r(" since "),Js=l("strong"),Js.textContent=al,Qn=m(),Ks=l("img"),$t=m(),hs=l("img"),jt=m(),V=l("p"),Jn=r("We can now update  "),Nt=new h(!1),Ot=r(":"),Wt=m(),gs=l("p"),Kn=r("New  "),qt=new h(!1),Ut=m(),us=l("p"),Xn=r("New "),At=new h(!1),Bt=m(),vs=l("p"),Yn=r("New "),Ft=new h(!1),Qt=m(),ds=l("p"),ds.textContent=el,Jt=m(),ys=l("p"),ys.innerHTML=ll,Kt=m(),fs=l("img"),Xt=m(),ws=l("p"),ws.textContent=ml,Yt=m(),R=l("ul"),Xs=l("li"),Xs.innerHTML=il,Zn=m(),bs=l("li"),x=l("p"),se=r("With "),Ys=l("em"),Ys.textContent=rl,ae=r(", we update the value function from a step, and we replace "),Zt=new h(!1),sn=r(", which we don’t know, with "),Zs=l("strong"),Zs.textContent=cl,te=m(),sa=l("img"),an=m(),pa=l("p"),this.h()},l(s){const t=tp("svelte-u9bgzb",document.head);_=p(t,"META",{name:!0,content:!0}),t.forEach(a),oa=i(s),ea=p(s,"P",{}),o(ea).forEach(a),ha=i(s),de(H.$$.fragment,s),ga=i(s),P=p(s,"P",{"data-svelte-h":!0}),g(P)!=="svelte-1akl2qa"&&(P.textContent=Me),ua=i(s),I=p(s,"P",{"data-svelte-h":!0}),g(I)!=="svelte-66f1fn"&&(I.innerHTML=ze),va=i(s),D=p(s,"P",{"data-svelte-h":!0}),g(D)!=="svelte-c9mnn7"&&(D.innerHTML=ke),da=i(s),M=p(s,"P",{});var ma=o(M);un=c(ma,"On one hand, Monte Carlo uses "),_s=p(ma,"STRONG",{"data-svelte-h":!0}),g(_s)!=="svelte-qfkr11"&&(_s.textContent=Le),vn=c(ma," On the other hand, Temporal Difference uses "),$=p(ma,"STRONG",{});var nn=o($);dn=c(nn,"only a step ( "),ya=u(nn,!1),fa=c(nn," ) to learn."),nn.forEach(a),ma.forEach(a),wa=i(s),j=p(s,"P",{"data-svelte-h":!0}),g(j)!=="svelte-15q9y0k"&&(j.innerHTML=Te),ba=i(s),de(N.$$.fragment,s),xa=i(s),z=p(s,"P",{});var ia=o(z);yn=c(ia,"Monte Carlo waits until the end of the episode, calculates  "),_a=u(ia,!1),Ma=c(ia," (return) and uses it as "),O=p(ia,"STRONG",{});var en=o(O);fn=c(en,"a target for updating  "),za=u(en,!1),ka=c(en,"."),en.forEach(a),ia.forEach(a),La=i(s),W=p(s,"P",{"data-svelte-h":!0}),g(W)!=="svelte-1qajh7u"&&(W.innerHTML=Se),Ta=i(s),q=p(s,"IMG",{src:!0,alt:!0}),Sa=i(s),U=p(s,"P",{"data-svelte-h":!0}),g(U)!=="svelte-w96c5b"&&(U.textContent=Ge),Ca=i(s),A=p(s,"IMG",{src:!0,alt:!0}),Ga=i(s),d=p(s,"UL",{});var y=o(d);Ms=p(y,"LI",{"data-svelte-h":!0}),g(Ms)!=="svelte-em32nl"&&(Ms.innerHTML=Re),wn=i(y),zs=p(y,"LI",{"data-svelte-h":!0}),g(zs)!=="svelte-1xtd55m"&&(zs.innerHTML=Ee),bn=i(y),ks=p(y,"LI",{"data-svelte-h":!0}),g(ks)!=="svelte-ragojc"&&(ks.innerHTML=He),xn=i(y),Ls=p(y,"LI",{"data-svelte-h":!0}),g(Ls)!=="svelte-bq5445"&&(Ls.innerHTML=Pe),_n=i(y),Ts=p(y,"LI",{"data-svelte-h":!0}),g(Ts)!=="svelte-10uvow2"&&(Ts.innerHTML=Ie),Mn=i(y),la=p(y,"LI",{});var hl=o(la);Ss=p(hl,"P",{});var ne=o(Ss);Cs=p(ne,"STRONG",{});var ee=o(Cs);zn=c(ee,"The agent will sum the total rewards "),Va=u(ee,!1),ee.forEach(a),kn=c(ne," (to see how well it did)."),ne.forEach(a),hl.forEach(a),Ln=i(y),B=p(y,"LI",{});var ln=o(B);Gs=p(ln,"P",{});var le=o(Gs);Tn=c(le,"It will then "),F=p(le,"STRONG",{});var pn=o(F);Sn=c(pn,"update "),Ra=u(pn,!1),Ea=c(pn," based on the formula"),pn.forEach(a),le.forEach(a),Cn=i(ln),Vs=p(ln,"IMG",{src:!0,alt:!0}),ln.forEach(a),Gn=i(y),Rs=p(y,"LI",{"data-svelte-h":!0}),g(Rs)!=="svelte-1a0nyac"&&(Rs.innerHTML=$e),y.forEach(a),Ha=i(s),Q=p(s,"P",{"data-svelte-h":!0}),g(Q)!=="svelte-12n0xeg"&&(Q.innerHTML=je),Pa=i(s),J=p(s,"IMG",{src:!0,alt:!0}),Ia=i(s),K=p(s,"P",{"data-svelte-h":!0}),g(K)!=="svelte-1xxhd0z"&&(K.textContent=Oe),Da=i(s),X=p(s,"UL",{"data-svelte-h":!0}),g(X)!=="svelte-fine1n"&&(X.innerHTML=We),$a=i(s),Y=p(s,"UL",{"data-svelte-h":!0}),g(Y)!=="svelte-h65p8t"&&(Y.innerHTML=qe),ja=i(s),Es=p(s,"UL",{});var gl=o(Es);Hs=p(gl,"LI",{});var pe=o(Hs);Vn=c(pe,"We have a list of state, action, rewards, next_state, "),Ps=p(pe,"STRONG",{});var me=o(Ps);Rn=c(me,"we need to calculate the return "),Na=u(me,!1),me.forEach(a),pe.forEach(a),gl.forEach(a),Oa=i(s),Z=p(s,"P",{});var ie=o(Z);Wa=u(ie,!1),qa=c(ie," (for simplicity, we don’t discount the rewards)"),ie.forEach(a),Ua=i(s),Is=p(s,"P",{});var ul=o(Is);Aa=u(ul,!1),ul.forEach(a),Ba=i(s),Ds=p(s,"P",{});var vl=o(Ds);Fa=u(vl,!1),vl.forEach(a),Qa=i(s),$s=p(s,"P",{});var dl=o($s);Ja=u(dl,!1),dl.forEach(a),Ka=i(s),js=p(s,"UL",{});var yl=o(js);ss=p(yl,"LI",{});var mn=o(ss);k=p(mn,"P",{});var aa=o(k);En=c(aa,"We can now compute the "),Ns=p(aa,"STRONG",{"data-svelte-h":!0}),g(Ns)!=="svelte-xvdw54"&&(Ns.textContent=Ue),Hn=i(aa),Xa=u(aa,!1),Ya=c(aa,":"),aa.forEach(a),Pn=i(mn),Os=p(mn,"IMG",{src:!0,alt:!0}),mn.forEach(a),yl.forEach(a),Za=i(s),Ws=p(s,"P",{});var fl=o(Ws);st=u(fl,!1),fl.forEach(a),at=i(s),qs=p(s,"P",{});var wl=o(qs);tt=u(wl,!1),wl.forEach(a),nt=i(s),Us=p(s,"P",{});var bl=o(Us);et=u(bl,!1),bl.forEach(a),lt=i(s),as=p(s,"IMG",{src:!0,alt:!0}),pt=i(s),de(ts.$$.fragment,s),mt=i(s),f=p(s,"P",{});var C=o(f);As=p(C,"STRONG",{});var re=o(As);In=c(re,"Temporal Difference, on the other hand, waits for only one interaction (one step) "),it=u(re,!1),re.forEach(a),Dn=c(C," to form a TD target and update "),rt=u(C,!1),ct=c(C," using "),ot=u(C,!1),ht=c(C," and "),gt=u(C,!1),ut=c(C,"."),C.forEach(a),vt=i(s),ns=p(s,"P",{});var ce=o(ns);$n=c(ce,"The idea with "),es=p(ce,"STRONG",{});var rn=o(es);jn=c(rn,"TD is to update the "),dt=u(rn,!1),yt=c(rn," at each step."),rn.forEach(a),ce.forEach(a),ft=i(s),L=p(s,"P",{});var ra=o(L);Nn=c(ra,"But because we didn’t experience an entire episode, we don’t have "),wt=u(ra,!1),bt=c(ra," (expected return). Instead, "),T=p(ra,"STRONG",{});var ta=o(T);On=c(ta,"we estimate "),xt=u(ta,!1),_t=c(ta," by adding "),Mt=u(ta,!1),zt=c(ta," and the discounted value of the next state."),ta.forEach(a),ra.forEach(a),kt=i(s),ls=p(s,"P",{});var oe=o(ls);Wn=c(oe,"This is called bootstrapping. It’s called this "),S=p(oe,"STRONG",{});var na=o(S);qn=c(na,"because TD bases its update in part on an existing estimate "),Lt=u(na,!1),Tt=c(na," and not a complete sample "),St=u(na,!1),Ct=c(na,"."),na.forEach(a),oe.forEach(a),Gt=i(s),ps=p(s,"IMG",{src:!0,alt:!0}),Vt=i(s),ms=p(s,"P",{"data-svelte-h":!0}),g(ms)!=="svelte-1a7834f"&&(ms.innerHTML=Qe),Rt=i(s),is=p(s,"IMG",{src:!0,alt:!0}),Et=i(s),rs=p(s,"P",{"data-svelte-h":!0}),g(rs)!=="svelte-1ijk2ql"&&(rs.textContent=Ke),Ht=i(s),cs=p(s,"IMG",{src:!0,alt:!0}),Pt=i(s),b=p(s,"UL",{});var E=o(b);Bs=p(E,"LI",{"data-svelte-h":!0}),g(Bs)!=="svelte-1uhtcgd"&&(Bs.innerHTML=Ye),Un=i(E),Fs=p(E,"LI",{"data-svelte-h":!0}),g(Fs)!=="svelte-1hykgj"&&(Fs.innerHTML=Ze),An=i(E),Qs=p(E,"LI",{"data-svelte-h":!0}),g(Qs)!=="svelte-toxj8r"&&(Qs.innerHTML=sl),Bn=i(E),os=p(E,"LI",{});var cn=o(os);G=p(cn,"P",{});var ca=o(G);Fn=c(ca,"It gets a reward  "),It=u(ca,!1),Dt=c(ca," since "),Js=p(ca,"STRONG",{"data-svelte-h":!0}),g(Js)!=="svelte-1cpiv0b"&&(Js.textContent=al),ca.forEach(a),Qn=i(cn),Ks=p(cn,"IMG",{src:!0,alt:!0}),cn.forEach(a),E.forEach(a),$t=i(s),hs=p(s,"IMG",{src:!0,alt:!0}),jt=i(s),V=p(s,"P",{});var on=o(V);Jn=c(on,"We can now update  "),Nt=u(on,!1),Ot=c(on,":"),on.forEach(a),Wt=i(s),gs=p(s,"P",{});var he=o(gs);Kn=c(he,"New  "),qt=u(he,!1),he.forEach(a),Ut=i(s),us=p(s,"P",{});var ge=o(us);Xn=c(ge,"New "),At=u(ge,!1),ge.forEach(a),Bt=i(s),vs=p(s,"P",{});var ue=o(vs);Yn=c(ue,"New "),Ft=u(ue,!1),ue.forEach(a),Qt=i(s),ds=p(s,"P",{"data-svelte-h":!0}),g(ds)!=="svelte-9mnez4"&&(ds.textContent=el),Jt=i(s),ys=p(s,"P",{"data-svelte-h":!0}),g(ys)!=="svelte-114rjrk"&&(ys.innerHTML=ll),Kt=i(s),fs=p(s,"IMG",{src:!0,alt:!0}),Xt=i(s),ws=p(s,"P",{"data-svelte-h":!0}),g(ws)!=="svelte-gcetae"&&(ws.textContent=ml),Yt=i(s),R=p(s,"UL",{});var hn=o(R);Xs=p(hn,"LI",{"data-svelte-h":!0}),g(Xs)!=="svelte-17v3eqc"&&(Xs.innerHTML=il),Zn=i(hn),bs=p(hn,"LI",{});var gn=o(bs);x=p(gn,"P",{});var xs=o(x);se=c(xs,"With "),Ys=p(xs,"EM",{"data-svelte-h":!0}),g(Ys)!=="svelte-1kiwr2w"&&(Ys.textContent=rl),ae=c(xs,", we update the value function from a step, and we replace "),Zt=u(xs,!1),sn=c(xs,", which we don’t know, with "),Zs=p(xs,"STRONG",{"data-svelte-h":!0}),g(Zs)!=="svelte-vbrp5s"&&(Zs.textContent=cl),xs.forEach(a),te=i(gn),sa=p(gn,"IMG",{src:!0,alt:!0}),gn.forEach(a),hn.forEach(a),an=i(s),pa=p(s,"P",{}),o(pa).forEach(a),this.h()},h(){v(_,"name","hf:doc:metadata"),v(_,"content",ep),ya.a=fa,_a.a=Ma,za.a=ka,w(q.src,Ce="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/monte-carlo-approach.jpg")||v(q,"src",Ce),v(q,"alt","Monte Carlo"),w(A.src,Ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-2.jpg")||v(A,"src",Ve),v(A,"alt","Monte Carlo"),Va.a=null,Ra.a=Ea,w(Vs.src,De="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3.jpg")||v(Vs,"src",De),v(Vs,"alt","Monte Carlo"),w(J.src,Ne="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3p.jpg")||v(J,"src",Ne),v(J,"alt","Monte Carlo"),Na.a=null,Wa.a=qa,Aa.a=null,Fa.a=null,Ja.a=null,Xa.a=Ya,w(Os.src,Ae="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5.jpg")||v(Os,"src",Ae),v(Os,"alt","Monte Carlo"),st.a=null,tt.a=null,et.a=null,w(as.src,Be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5p.jpg")||v(as,"src",Be),v(as,"alt","Monte Carlo"),it.a=null,rt.a=ct,ot.a=ht,gt.a=ut,dt.a=yt,wt.a=bt,xt.a=_t,Mt.a=zt,Lt.a=Tt,St.a=Ct,w(ps.src,Fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1.jpg")||v(ps,"src",Fe),v(ps,"alt","Temporal Difference"),w(is.src,Je="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1p.jpg")||v(is,"src",Je),v(is,"alt","Temporal Difference"),w(cs.src,Xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2.jpg")||v(cs,"src",Xe),v(cs,"alt","Temporal Difference"),It.a=Dt,w(Ks.src,tl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2p.jpg")||v(Ks,"src",tl),v(Ks,"alt","Temporal Difference"),w(hs.src,nl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3.jpg")||v(hs,"src",nl),v(hs,"alt","Temporal Difference"),Nt.a=Ot,qt.a=null,At.a=null,Ft.a=null,w(fs.src,pl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3p.jpg")||v(fs,"src",pl),v(fs,"alt","Temporal Difference"),Zt.a=sn,w(sa.src,ol="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Summary.jpg")||v(sa,"src",ol),v(sa,"alt","Summary")},m(s,t){n(document.head,_),e(s,oa,t),e(s,ea,t),e(s,ha,t),ye(H,s,t),e(s,ga,t),e(s,P,t),e(s,ua,t),e(s,I,t),e(s,va,t),e(s,D,t),e(s,da,t),e(s,M,t),n(M,un),n(M,_s),n(M,vn),n(M,$),n($,dn),ya.m(xl,$),n($,fa),e(s,wa,t),e(s,j,t),e(s,ba,t),ye(N,s,t),e(s,xa,t),e(s,z,t),n(z,yn),_a.m(_l,z),n(z,Ma),n(z,O),n(O,fn),za.m(Ml,O),n(O,ka),e(s,La,t),e(s,W,t),e(s,Ta,t),e(s,q,t),e(s,Sa,t),e(s,U,t),e(s,Ca,t),e(s,A,t),e(s,Ga,t),e(s,d,t),n(d,Ms),n(d,wn),n(d,zs),n(d,bn),n(d,ks),n(d,xn),n(d,Ls),n(d,_n),n(d,Ts),n(d,Mn),n(d,la),n(la,Ss),n(Ss,Cs),n(Cs,zn),Va.m(zl,Cs),n(Ss,kn),n(d,Ln),n(d,B),n(B,Gs),n(Gs,Tn),n(Gs,F),n(F,Sn),Ra.m(kl,F),n(F,Ea),n(B,Cn),n(B,Vs),n(d,Gn),n(d,Rs),e(s,Ha,t),e(s,Q,t),e(s,Pa,t),e(s,J,t),e(s,Ia,t),e(s,K,t),e(s,Da,t),e(s,X,t),e(s,$a,t),e(s,Y,t),e(s,ja,t),e(s,Es,t),n(Es,Hs),n(Hs,Vn),n(Hs,Ps),n(Ps,Rn),Na.m(Ll,Ps),e(s,Oa,t),e(s,Z,t),Wa.m(Tl,Z),n(Z,qa),e(s,Ua,t),e(s,Is,t),Aa.m(Sl,Is),e(s,Ba,t),e(s,Ds,t),Fa.m(Cl,Ds),e(s,Qa,t),e(s,$s,t),Ja.m(Gl,$s),e(s,Ka,t),e(s,js,t),n(js,ss),n(ss,k),n(k,En),n(k,Ns),n(k,Hn),Xa.m(Vl,k),n(k,Ya),n(ss,Pn),n(ss,Os),e(s,Za,t),e(s,Ws,t),st.m(Rl,Ws),e(s,at,t),e(s,qs,t),tt.m(El,qs),e(s,nt,t),e(s,Us,t),et.m(Hl,Us),e(s,lt,t),e(s,as,t),e(s,pt,t),ye(ts,s,t),e(s,mt,t),e(s,f,t),n(f,As),n(As,In),it.m(Pl,As),n(f,Dn),rt.m(Il,f),n(f,ct),ot.m(Dl,f),n(f,ht),gt.m($l,f),n(f,ut),e(s,vt,t),e(s,ns,t),n(ns,$n),n(ns,es),n(es,jn),dt.m(jl,es),n(es,yt),e(s,ft,t),e(s,L,t),n(L,Nn),wt.m(Nl,L),n(L,bt),n(L,T),n(T,On),xt.m(Ol,T),n(T,_t),Mt.m(Wl,T),n(T,zt),e(s,kt,t),e(s,ls,t),n(ls,Wn),n(ls,S),n(S,qn),Lt.m(ql,S),n(S,Tt),St.m(Ul,S),n(S,Ct),e(s,Gt,t),e(s,ps,t),e(s,Vt,t),e(s,ms,t),e(s,Rt,t),e(s,is,t),e(s,Et,t),e(s,rs,t),e(s,Ht,t),e(s,cs,t),e(s,Pt,t),e(s,b,t),n(b,Bs),n(b,Un),n(b,Fs),n(b,An),n(b,Qs),n(b,Bn),n(b,os),n(os,G),n(G,Fn),It.m(Al,G),n(G,Dt),n(G,Js),n(os,Qn),n(os,Ks),e(s,$t,t),e(s,hs,t),e(s,jt,t),e(s,V,t),n(V,Jn),Nt.m(Bl,V),n(V,Ot),e(s,Wt,t),e(s,gs,t),n(gs,Kn),qt.m(Fl,gs),e(s,Ut,t),e(s,us,t),n(us,Xn),At.m(Ql,us),e(s,Bt,t),e(s,vs,t),n(vs,Yn),Ft.m(Jl,vs),e(s,Qt,t),e(s,ds,t),e(s,Jt,t),e(s,ys,t),e(s,Kt,t),e(s,fs,t),e(s,Xt,t),e(s,ws,t),e(s,Yt,t),e(s,R,t),n(R,Xs),n(R,Zn),n(R,bs),n(bs,x),n(x,se),n(x,Ys),n(x,ae),Zt.m(Kl,x),n(x,sn),n(x,Zs),n(bs,te),n(bs,sa),e(s,an,t),e(s,pa,t),tn=!0},p:Yl,i(s){tn||(fe(H.$$.fragment,s),fe(N.$$.fragment,s),fe(ts.$$.fragment,s),tn=!0)},o(s){we(H.$$.fragment,s),we(N.$$.fragment,s),we(ts.$$.fragment,s),tn=!1},d(s){s&&(a(oa),a(ea),a(ha),a(ga),a(P),a(ua),a(I),a(va),a(D),a(da),a(M),a(wa),a(j),a(ba),a(xa),a(z),a(La),a(W),a(Ta),a(q),a(Sa),a(U),a(Ca),a(A),a(Ga),a(d),a(Ha),a(Q),a(Pa),a(J),a(Ia),a(K),a(Da),a(X),a($a),a(Y),a(ja),a(Es),a(Oa),a(Z),a(Ua),a(Is),a(Ba),a(Ds),a(Qa),a($s),a(Ka),a(js),a(Za),a(Ws),a(at),a(qs),a(nt),a(Us),a(lt),a(as),a(pt),a(mt),a(f),a(vt),a(ns),a(ft),a(L),a(kt),a(ls),a(Gt),a(ps),a(Vt),a(ms),a(Rt),a(is),a(Et),a(rs),a(Ht),a(cs),a(Pt),a(b),a($t),a(hs),a(jt),a(V),a(Wt),a(gs),a(Ut),a(us),a(Bt),a(vs),a(Qt),a(ds),a(Jt),a(ys),a(Kt),a(fs),a(Xt),a(ws),a(Yt),a(R),a(an),a(pa)),a(_),be(H,s),be(N,s),be(ts,s)}}}const ep='{"title":"Monte Carlo vs Temporal Difference Learning","local":"mc-vs-td","sections":[{"title":"Monte Carlo: learning at the end of the episode","local":"monte-carlo","sections":[],"depth":2},{"title":"Temporal Difference Learning: learning at each step","local":"td-learning","sections":[],"depth":2}],"depth":1}';function lp(_e){return Zl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class rp extends sp{constructor(_){super(),ap(this,_,lp,np,Xl,{})}}export{rp as component};
